// MoI Nodeedit
// Solids v.0.85 - Max Smirnov, 2016
// litegraph.js library (c) Javi Agenjo http://tamats.com

(function(){

// Cone
function Cone()
{
	this.addInput("Center","pointarray");
	this.addInput("Radius","numarray");
	this.addInput("Height","numarray");
	this.addOutput("Out","objectlist");
	this.properties = { mode:["Long","Long","Short"], radius:[1], height:[1] };
}

Cone.title = "Cone";
Cone.desc = "Cone";

Cone.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, this.properties.radius, this.properties.height);
	this.properties.radius = data.inputs[1];
	this.properties.height = data.inputs[2];
	this.setOutputData(0, data.outputs[0]);
}
Cone.prototype.multiProcess = function(c, r, h)
{
	var frame = c.getFrame(0);
	return [factory('cone', true, frame, null, r, frame.evaluate(0,0,h))];
}

LiteGraph.registerNodeType("Solids/Cone", Cone);

// Cylinder
function Cylinder()
{
	this.addInput("Center","pointarray");
	this.addInput("Radius","numarray");
	this.addInput("Height","numarray");
	this.addOutput("Out","objectlist");
	this.properties = { mode:["Long","Long","Short"], radius:[1], height:[1] };
}

Cylinder.title = "Cylinder";
Cylinder.desc = "Cylinder";

Cylinder.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, this.properties.radius, this.properties.height);
	this.properties.radius = data.inputs[1];
	this.properties.height = data.inputs[2];
	this.setOutputData(0, data.outputs[0]);
}

Cylinder.prototype.multiProcess = function(c, r, h)
{
	var frame = c.getFrame(0);
	return [factory('cylinder', true, frame, null, r, frame.evaluate(0,0,h))];
}

LiteGraph.registerNodeType("Solids/Cylinder", Cylinder);

// Sphere
function Sphere()
{
	this.addInput("Center","pointarray");
	this.addInput("Radius","numarray");
	this.addOutput("Out","objectlist");
	this.properties = { mode:["Long","Long","Short"], radius:[1] };
}

Sphere.title = "Sphere";
Sphere.desc = "Sphere";

Sphere.prototype.onExecute = function()
{
	var data = this.processInOut(this.properties.mode[0], this.multiProcess, null, this.properties.radius);
	this.properties.radius = data.inputs[1];
	this.setOutputData(0, data.outputs[0]);
}

Sphere.prototype.multiProcess = function(c, r)
{
	return [factory('sphere', true, c.getFrame(0), null, r)];
}

LiteGraph.registerNodeType("Solids/Sphere", Sphere);

})();